﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace ExpandableXamDataGrid
{
    public abstract class Model
    {
        public static readonly Model0 Root;

        static Model()
        {
            Root = new Model0
            {
                Name = "Root",
                Children = new ObservableCollection<Model1>
                {
                    new Model1
                    {
                        Name = "R.C[0]",
                        Child = new Model1 { Name = "R.C[0].Child" }
#if children
                        Children = new ObservableCollection<Model1>
                        {
                            new Model1 { Name = "R.C[0].C[0]" },
                            new Model1 { Name = "R.C[0].C[1]" }
                        }
#endif
                    },
                    new Model1
                    {
                        Name = "R.C[1]",
                        Child = new Model1 { Name = "R.C[0].Child" }
#if children
                        Children = new ObservableCollection<Model1>
                        {
                            new Model1 { Name = "R.C[1].C[0]" },
                            new Model1 { Name = "R.C[1].C[1]" }
                        }
#endif
                    }
                }
            };
        }
    }

    public class Model1 : Model
    {
        public string Name { get; set; }
        public Model1 Child { get; set; }
#if children
        public ObservableCollection<Model1> Children { get; set; }
#endif

        public Model1()
        {
#if children
            Children = new ObservableCollection<Model1>();
#endif
        }

        public override string ToString()
        {
            return "Model1[" + Name + "]";
        }
    }

    public class Model0 : Model
    {
        public string Name { get; set; }
        public ObservableCollection<Model1> Children { get; set; }

        public Model0()
        {
            Children = new ObservableCollection<Model1>();
        }
    }
}
